defmodule NullaWeb.ActivityPub.ActorController do
  use NullaWeb, :controller
  alias Nulla.ActivityPub
  alias Nulla.Models.Actor

  def show(conn, %{"username" => username}) do
    domain = NullaWeb.Endpoint.host()

    case Actor.get_actor(preferredUsername: username, domain: domain) do
      nil ->
        conn
        |> put_status(:not_found)
        |> json(%{error: "Not Found"})

      %Actor{} = actor ->
        conn
        |> put_resp_content_type("application/activity+json")
        |> send_resp(200, Jason.encode!(ActivityPub.actor(actor)))
    end
  end
end
